/****************************************************************************
**
** Copyright (C) 2018 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt 3D Studio.
**
** $QT_BEGIN_LICENSE:BSD$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** BSD License Usage
** Alternatively, you may use this file under the terms of the BSD license
** as follows:
**
** "Redistribution and use in source and binary forms, with or without
** modification, are permitted provided that the following conditions are
** met:
**   * Redistributions of source code must retain the above copyright
**     notice, this list of conditions and the following disclaimer.
**   * Redistributions in binary form must reproduce the above copyright
**     notice, this list of conditions and the following disclaimer in
**     the documentation and/or other materials provided with the
**     distribution.
**   * Neither the name of The Qt Company Ltd nor the names of its
**     contributors may be used to endorse or promote products derived
**     from this software without specific prior written permission.
**
**
** THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
** "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
** LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
** A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
** OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
** SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
** LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
** DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
** THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
** (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
** OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE."
**
** $QT_END_LICENSE$
**
****************************************************************************/

import QtQuick 2.0
import QtStudio3D 2.1
import QtQuick.Controls 2.2
import QtQuick.Layouts 1.0

Rectangle {
    id: root
    color: "lightGray"

    Studio3DEngine {
        id: s3d
    }

    Rectangle {
        border.color: "black"
        border.width: 4
        color: "transparent"
        anchors.fill: parent

        Layer3D {
            engine: s3d
            anchors.fill: parent
            Camera3D {
                id: camera
                position: Qt.vector3d(0, 0, -500)
            }

            Light3D {
                id: light
                position: Qt.vector3d(0, 200, 0)
                Model3D {
                    id: lightModel
                    mesh: "#Sphere"
                    scale: Qt.vector3d(0.3, 0.3, 0.3)
                }

                SequentialAnimation on position {
                    loops: Animation.Infinite
                    PropertyAnimation { duration: 2000; to: Qt.vector3d(500, 200, 0) }
                    PropertyAnimation { duration: 2000; to: Qt.vector3d(-500, 200, 0) }
                }
            }

            Model3D {
                id: model
                mesh: "#Cube"
                visible: true
                anchors.fill: parent

                scale: Qt.vector3d(1, 1, 1);
                SequentialAnimation on rotation {
                    loops: Animation.Infinite
                    PropertyAnimation { duration: 2000; to: Qt.vector3d(0, 360, 360) }
                }
            }
        }
    }

    Button {
        anchors.bottom: parent.bottom
        text: "Profile UI"
        onClicked: {
            prof.visible = !prof.visible
        }
        focusPolicy: Qt.NoFocus
    }

    Rectangle {
        id: prof
        visible: false
        anchors.fill: parent
        anchors.margins: 40
        border.color: "green"
        border.width: 4
        color: "transparent"

        Studio3DProfiler {
            anchors.fill: parent
            focus: true
        }
    }
}
